Index: /trunk/src/bindings/scripts/ScriptMgr.h
===================================================================
--- /trunk/src/bindings/scripts/ScriptMgr.h (revision 149)
+++ /trunk/src/bindings/scripts/ScriptMgr.h (revision 260)
@@ -25,5 +25,5 @@
 class WorldObject;
 
-#define MAX_SCRIPTS         1000                            //72 bytes each (approx 71kb)
+#define MAX_SCRIPTS         5000                            //72 bytes each (approx 351kb)
 #define VISIBLE_RANGE       (166.0f)                        //MAX visible range (size of grid)
 #define DEFAULT_TEXT        "<Trinity Script Text Entry Missing!>"
@@ -32,37 +32,36 @@
 {
     Script() :
-pGossipHello(NULL), pQuestAccept(NULL), pGossipSelect(NULL), pGossipSelectWithCode(NULL),
-pQuestSelect(NULL), pQuestComplete(NULL), pNPCDialogStatus(NULL), pGODialogStatus(NULL), pChooseReward(NULL),
-pItemHello(NULL), pGOHello(NULL), pAreaTrigger(NULL), pItemQuestAccept(NULL), pGOQuestAccept(NULL),
-pGOChooseReward(NULL),pReceiveEmote(NULL),pItemUse(NULL), GetAI(NULL), GetInstanceData(NULL)
-{}
+        pGossipHello(NULL), pQuestAccept(NULL), pGossipSelect(NULL), pGossipSelectWithCode(NULL),
+        pQuestSelect(NULL), pQuestComplete(NULL), pNPCDialogStatus(NULL), pGODialogStatus(NULL), pChooseReward(NULL),
+        pItemHello(NULL), pGOHello(NULL), pAreaTrigger(NULL), pItemQuestAccept(NULL), pGOQuestAccept(NULL),
+        pGOChooseReward(NULL),pReceiveEmote(NULL),pItemUse(NULL), GetAI(NULL), GetInstanceData(NULL)
+    {}
 
-std::string Name;
+    std::string Name;
 
-// Quest/gossip Methods to be scripted
-bool (*pGossipHello         )(Player*, Creature*);
-bool (*pQuestAccept         )(Player*, Creature*, Quest const* );
-bool (*pGossipSelect        )(Player*, Creature*, uint32 , uint32  );
-bool (*pGossipSelectWithCode)(Player*, Creature*, uint32 , uint32 , const char* );
-bool (*pQuestSelect         )(Player*, Creature*, Quest const* );
-bool (*pQuestComplete       )(Player*, Creature*, Quest const* );
-uint32 (*pNPCDialogStatus   )(Player*, Creature* );
-uint32 (*pGODialogStatus    )(Player *player, GameObject * _GO );
-bool (*pChooseReward        )(Player*, Creature*, Quest const*, uint32 );
-bool (*pItemHello           )(Player*, Item*, Quest const* );
-bool (*pGOHello             )(Player*, GameObject* );
-bool (*pAreaTrigger         )(Player*, AreaTriggerEntry* );
-bool (*pItemQuestAccept     )(Player*, Item *, Quest const* );
-bool (*pGOQuestAccept       )(Player*, GameObject*, Quest const* );
-bool (*pGOChooseReward      )(Player*, GameObject*_GO, Quest const*, uint32 );
-bool (*pReceiveEmote        )(Player*, Creature*, uint32 );
-bool (*pItemUse             )(Player*, Item*, SpellCastTargets const& );
+    //Methods to be scripted
+    bool (*pGossipHello         )(Player*, Creature*);
+    bool (*pQuestAccept         )(Player*, Creature*, Quest const* );
+    bool (*pGossipSelect        )(Player*, Creature*, uint32 , uint32 );
+    bool (*pGossipSelectWithCode)(Player*, Creature*, uint32 , uint32 , const char* );
+    bool (*pQuestSelect         )(Player*, Creature*, Quest const* );
+    bool (*pQuestComplete       )(Player*, Creature*, Quest const* );
+    uint32 (*pNPCDialogStatus   )(Player*, Creature* );
+    uint32 (*pGODialogStatus    )(Player*, GameObject * _GO );
+    bool (*pChooseReward        )(Player*, Creature*, Quest const*, uint32 );
+    bool (*pItemHello           )(Player*, Item*, Quest const* );
+    bool (*pGOHello             )(Player*, GameObject* );
+    bool (*pAreaTrigger         )(Player*, AreaTriggerEntry* );
+    bool (*pItemQuestAccept     )(Player*, Item *, Quest const* );
+    bool (*pGOQuestAccept       )(Player*, GameObject*, Quest const* );
+    bool (*pGOChooseReward      )(Player*, GameObject*, Quest const*, uint32 );
+    bool (*pReceiveEmote        )(Player*, Creature*, uint32 );
+    bool (*pItemUse             )(Player*, Item*, SpellCastTargets const& );
 
-CreatureAI* (*GetAI)(Creature*);
-InstanceData* (*GetInstanceData)(Map*);
+    CreatureAI* (*GetAI)(Creature*);
+    InstanceData* (*GetInstanceData)(Map*);
+
+    void RegisterSelf();
 };
-
-extern int nrscripts;
-extern Script *m_scripts[MAX_SCRIPTS];
 
 //Generic scripting text function
Index: /trunk/src/bindings/scripts/scripts/npc/npc_innkeeper.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/npc/npc_innkeeper.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/npc/npc_innkeeper.cpp (revision 260)
@@ -141,4 +141,4 @@
     newscript->pGossipHello = &GossipHello_npc_innkeeper;
     newscript->pGossipSelect = &GossipSelect_npc_innkeeper;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/npc/npcs_special.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/npc/npcs_special.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/npc/npcs_special.cpp (revision 260)
@@ -836,15 +836,15 @@
     newscript->pQuestAccept =   &QuestAccept_npc_chicken_cluck;
     newscript->pQuestComplete = &QuestComplete_npc_chicken_cluck;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="npc_dancing_flames";
     newscript->pReceiveEmote =  &ReceiveEmote_npc_dancing_flames;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="npc_injured_patient";
     newscript->GetAI = GetAI_npc_injured_patient;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -852,10 +852,10 @@
     newscript->GetAI = GetAI_npc_doctor;
     newscript->pQuestAccept = &QuestAccept_npc_doctor;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="npc_guardian";
     newscript->GetAI = GetAI_npc_guardian;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -863,5 +863,5 @@
     newscript->pGossipHello =  &GossipHello_npc_mount_vendor;
     newscript->pGossipSelect = &GossipSelect_npc_mount_vendor;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -869,5 +869,5 @@
     newscript->pGossipHello =  &GossipHello_npc_rogue_trainer;
     newscript->pGossipSelect = &GossipSelect_npc_rogue_trainer;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -875,4 +875,4 @@
     newscript->pGossipHello = &GossipHello_npc_sayge;
     newscript->pGossipSelect = &GossipSelect_npc_sayge;
-    m_scripts[nrscripts++] = newscript;
-}
+    newscript->RegisterSelf();
+}
Index: /trunk/src/bindings/scripts/scripts/npc/npc_professions.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/npc/npc_professions.cpp (revision 91)
+++ /trunk/src/bindings/scripts/scripts/npc/npc_professions.cpp (revision 260)
@@ -1178,5 +1178,5 @@
     newscript->pGossipHello =  &GossipHello_npc_prof_alchemy;
     newscript->pGossipSelect = &GossipSelect_npc_prof_alchemy;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -1184,5 +1184,5 @@
     newscript->pGossipHello =  &GossipHello_npc_prof_blacksmith;
     newscript->pGossipSelect = &GossipSelect_npc_prof_blacksmith;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -1190,5 +1190,5 @@
     newscript->pGossipHello =  &GossipHello_npc_prof_leather;
     newscript->pGossipSelect = &GossipSelect_npc_prof_leather;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -1196,5 +1196,5 @@
     newscript->pGossipHello =  &GossipHello_npc_prof_tailor;
     newscript->pGossipSelect = &GossipSelect_npc_prof_tailor;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     /*newscript = new Script;
@@ -1202,4 +1202,4 @@
     newscript->pGOHello =  &GOHello_go_soothsaying_for_dummies;
     //newscript->pGossipSelect = &GossipSelect_go_soothsaying_for_dummies;
-    m_scripts[nrscripts++] = newscript;*/
-}
+    newscript->RegisterSelf();*/
+}
Index: /trunk/src/bindings/scripts/scripts/guard/guards.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/guard/guards.cpp (revision 159)
+++ /trunk/src/bindings/scripts/scripts/guard/guards.cpp (revision 260)
@@ -3981,5 +3981,5 @@
     newscript->pGossipSelect         = &GossipSelect_guard_azuremyst;
     newscript->GetAI = GetAI_guard_azuremyst;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -3988,10 +3988,10 @@
     newscript->pGossipSelect         = &GossipSelect_guard_bluffwatcher;
     newscript->GetAI = GetAI_guard_bluffwatcher;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="guard_contested";
     newscript->GetAI = GetAI_guard_contested;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -4000,5 +4000,5 @@
     newscript->pGossipSelect         = &GossipSelect_guard_darnassus;
     newscript->GetAI = GetAI_guard_darnassus;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -4007,5 +4007,5 @@
     newscript->pGossipSelect         = &GossipSelect_guard_dunmorogh;
     newscript->GetAI = GetAI_guard_dunmorogh;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -4014,5 +4014,5 @@
     newscript->pGossipSelect         = &GossipSelect_guard_durotar;
     newscript->GetAI = GetAI_guard_durotar;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -4021,5 +4021,5 @@
     newscript->pGossipSelect         = &GossipSelect_guard_elwynnforest;
     newscript->GetAI = GetAI_guard_elwynnforest;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -4028,5 +4028,5 @@
     newscript->pGossipSelect         = &GossipSelect_guard_eversong;
     newscript->GetAI = GetAI_guard_eversong;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -4035,5 +4035,5 @@
     newscript->pGossipSelect         = &GossipSelect_guard_exodar;
     newscript->GetAI = GetAI_guard_exodar;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -4042,5 +4042,5 @@
     newscript->pGossipSelect         = &GossipSelect_guard_ironforge;
     newscript->GetAI = GetAI_guard_ironforge;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -4049,5 +4049,5 @@
     newscript->pGossipSelect         = &GossipSelect_guard_mulgore;
     newscript->GetAI = GetAI_guard_mulgore;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -4057,5 +4057,5 @@
     newscript->pReceiveEmote         = &ReceiveEmote_guard_orgrimmar;
     newscript->GetAI = GetAI_guard_orgrimmar;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -4064,5 +4064,5 @@
     newscript->pGossipSelect         = &GossipSelect_guard_shattrath;
     newscript->GetAI = GetAI_guard_shattrath;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -4071,5 +4071,5 @@
     newscript->pGossipHello          = &GossipHello_guard_shattrath_aldor;
     newscript->pGossipSelect         = &GossipSelect_guard_shattrath_aldor;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -4078,5 +4078,5 @@
     newscript->pGossipHello          = &GossipHello_guard_shattrath_scryer;
     newscript->pGossipSelect         = &GossipSelect_guard_shattrath_scryer;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -4085,5 +4085,5 @@
     newscript->pGossipSelect         = &GossipSelect_guard_silvermoon;
     newscript->GetAI = GetAI_guard_silvermoon;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -4093,5 +4093,5 @@
     newscript->pReceiveEmote         = &ReceiveEmote_guard_stormwind;
     newscript->GetAI = GetAI_guard_stormwind;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -4100,5 +4100,5 @@
     newscript->pGossipSelect         = &GossipSelect_guard_teldrassil;
     newscript->GetAI = GetAI_guard_teldrassil;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -4107,5 +4107,5 @@
     newscript->pGossipSelect         = &GossipSelect_guard_tirisfal;
     newscript->GetAI = GetAI_guard_tirisfal;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -4114,4 +4114,4 @@
     newscript->pGossipSelect         = &GossipSelect_guard_undercity;
     newscript->GetAI = GetAI_guard_undercity;
-    m_scripts[nrscripts++] = newscript;
-}
+    newscript->RegisterSelf();
+}
Index: /trunk/src/bindings/scripts/scripts/go/go_scripts.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/go/go_scripts.cpp (revision 239)
+++ /trunk/src/bindings/scripts/scripts/go/go_scripts.cpp (revision 260)
@@ -166,44 +166,44 @@
     newscript->Name="go_northern_crystal_pylon";
     newscript->pGOHello =           &GOHello_go_northern_crystal_pylon;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="go_eastern_crystal_pylon";
     newscript->pGOHello =           &GOHello_go_eastern_crystal_pylon;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="go_western_crystal_pylon";
     newscript->pGOHello =           &GOHello_go_western_crystal_pylon;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="go_barov_journal";
     newscript->pGOHello =           &GOHello_go_barov_journal;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="go_field_repair_bot_74A";
     newscript->pGOHello =           &GOHello_go_field_repair_bot_74A;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="go_orb_of_command";
     newscript->pGOHello =           &GOHello_go_orb_of_command;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="go_tablet_of_madness";
     newscript->pGOHello =           &GOHello_go_tablet_of_madness;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="go_tablet_of_the_seven";
     newscript->pGOHello =           &GOHello_go_tablet_of_the_seven;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="go_teleporter";
     newscript->pGOHello =           &GOHello_go_teleporter;
-    m_scripts[nrscripts++] = newscript;
-}
+    newscript->RegisterSelf();
+}
Index: /trunk/src/bindings/scripts/scripts/boss/boss_taerar.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/boss/boss_taerar.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/boss/boss_taerar.cpp (revision 260)
@@ -298,9 +298,9 @@
     newscript->Name="boss_taerar";
     newscript->GetAI = GetAI_boss_taerar;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="boss_shade_of_taerar";
     newscript->GetAI = GetAI_boss_shadeoftaerar;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/boss/boss_ysondre.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/boss/boss_ysondre.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/boss/boss_ysondre.cpp (revision 260)
@@ -238,9 +238,9 @@
     newscript->Name="boss_ysondre";
     newscript->GetAI = GetAI_boss_ysondre;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="mob_dementeddruids";
     newscript->GetAI = GetAI_mob_dementeddruids;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/boss/boss_emeriss.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/boss/boss_emeriss.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/boss/boss_emeriss.cpp (revision 260)
@@ -153,4 +153,4 @@
     newscript->Name="boss_emeriss";
     newscript->GetAI = GetAI_boss_emeriss;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/creature/mob_generic_creature.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/creature/mob_generic_creature.cpp (revision 158)
+++ /trunk/src/bindings/scripts/scripts/creature/mob_generic_creature.cpp (revision 260)
@@ -169,4 +169,4 @@
     newscript->Name="generic_creature";
     newscript->GetAI = GetAI_generic_creature;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/creature/mob_event_ai.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/creature/mob_event_ai.cpp (revision 239)
+++ /trunk/src/bindings/scripts/scripts/creature/mob_event_ai.cpp (revision 260)
@@ -1401,4 +1401,4 @@
     newscript->Name="mob_eventai";
     newscript->GetAI = GetAI_Mob_EventAI;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/custom/test.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/custom/test.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/custom/test.cpp (revision 260)
@@ -197,4 +197,4 @@
     newscript->pGossipHello          = &GossipHello_npc_test;
     newscript->pGossipSelect         = &GossipSelect_npc_test;
-    m_scripts[nrscripts++] = newscript;
-}
+    newscript->RegisterSelf();
+}
Index: /trunk/src/bindings/scripts/scripts/custom/custom_gossip_codebox.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/custom/custom_gossip_codebox.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/custom/custom_gossip_codebox.cpp (revision 260)
@@ -78,4 +78,4 @@
     newscript->pGossipSelect =          &GossipSelect_custom_gossip_codebox;
     newscript->pGossipSelectWithCode =  &GossipSelectWithCode_custom_gossip_codebox;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/custom/custom_example.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/custom/custom_example.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/custom/custom_example.cpp (revision 260)
@@ -274,4 +274,4 @@
     newscript->pGossipSelect = &GossipSelect_custom_example;
     newscript->pReceiveEmote = &ReceiveEmote_custom_example;
-    m_scripts[nrscripts++] = newscript;
-}
+    newscript->RegisterSelf();
+}
Index: /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_hazzarah.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_hazzarah.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_hazzarah.cpp (revision 260)
@@ -97,4 +97,4 @@
     newscript->Name="boss_hazzarah";
     newscript->GetAI = GetAI_boss_hazzarah;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_thekal.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_thekal.cpp (revision 109)
+++ /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_thekal.cpp (revision 260)
@@ -532,14 +532,14 @@
     newscript->Name="boss_thekal";
     newscript->GetAI = GetAI_boss_thekal;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="mob_zealot_lorkhan";
     newscript->GetAI = GetAI_mob_zealot_lorkhan;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="mob_zealot_zath";
     newscript->GetAI = GetAI_mob_zealot_zath;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_jeklik.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_jeklik.cpp (revision 109)
+++ /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_jeklik.cpp (revision 260)
@@ -289,9 +289,9 @@
     newscript->Name="boss_jeklik";
     newscript->GetAI = GetAI_boss_jeklik;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="mob_batrider";
     newscript->GetAI = GetAI_mob_batrider;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_wushoolay.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_wushoolay.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_wushoolay.cpp (revision 260)
@@ -81,4 +81,4 @@
     newscript->Name="boss_wushoolay";
     newscript->GetAI = GetAI_boss_wushoolay;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_venoxis.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_venoxis.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_venoxis.cpp (revision 260)
@@ -197,4 +197,4 @@
     newscript->Name="boss_venoxis";
     newscript->GetAI = GetAI_boss_venoxis;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_grilek.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_grilek.cpp (revision 109)
+++ /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_grilek.cpp (revision 260)
@@ -89,4 +89,4 @@
     newscript->Name="boss_grilek";
     newscript->GetAI = GetAI_boss_grilek;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/zulgurub/instance_zulgurub.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/zulgurub/instance_zulgurub.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/zone/zulgurub/instance_zulgurub.cpp (revision 260)
@@ -235,4 +235,4 @@
     newscript->Name = "instance_zulgurub";
     newscript->GetInstanceData = GetInstanceData_instance_zulgurub;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_renataki.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_renataki.cpp (revision 109)
+++ /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_renataki.cpp (revision 260)
@@ -148,4 +148,4 @@
     newscript->Name="boss_renataki";
     newscript->GetAI = GetAI_boss_renataki;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_hakkar.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_hakkar.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_hakkar.cpp (revision 260)
@@ -253,4 +253,4 @@
     newscript->Name="boss_hakkar";
     newscript->GetAI = GetAI_boss_hakkar;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_arlokk.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_arlokk.cpp (revision 109)
+++ /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_arlokk.cpp (revision 260)
@@ -208,4 +208,4 @@
     newscript->Name="boss_arlokk";
     newscript->GetAI = GetAI_boss_arlokk;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_jindo.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_jindo.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_jindo.cpp (revision 260)
@@ -259,14 +259,14 @@
     newscript->Name="boss_jindo";
     newscript->GetAI = GetAI_boss_jindo;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="mob_healing_ward";
     newscript->GetAI = GetAI_mob_healing_ward;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="mob_shade_of_jindo";
     newscript->GetAI = GetAI_mob_shade_of_jindo;
-    m_scripts[nrscripts++] = newscript;
-}
+    newscript->RegisterSelf();
+}
Index: /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_mandokir.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_mandokir.cpp (revision 109)
+++ /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_mandokir.cpp (revision 260)
@@ -303,9 +303,9 @@
     newscript->Name="boss_mandokir";
     newscript->GetAI = GetAI_boss_mandokir;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="mob_ohgan";
     newscript->GetAI = GetAI_mob_ohgan;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_marli.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_marli.cpp (revision 109)
+++ /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_marli.cpp (revision 260)
@@ -245,9 +245,9 @@
     newscript->Name="boss_marli";
     newscript->GetAI = GetAI_boss_marli;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="mob_spawn_of_marli";
     newscript->GetAI = GetAI_mob_spawn_of_marli;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_gahzranka.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_gahzranka.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/zone/zulgurub/boss_gahzranka.cpp (revision 260)
@@ -89,4 +89,4 @@
     newscript->Name="boss_gahzranka";
     newscript->GetAI = GetAI_boss_gahzranka;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/hellfire_citadel/blood_furnace/boss_broggok.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/hellfire_citadel/blood_furnace/boss_broggok.cpp (revision 166)
+++ /trunk/src/bindings/scripts/scripts/zone/hellfire_citadel/blood_furnace/boss_broggok.cpp (revision 260)
@@ -124,9 +124,9 @@
     newscript->Name="boss_broggok";
     newscript->GetAI = GetAI_boss_broggokAI;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="mob_broggok_poisoncloud";
     newscript->GetAI = GetAI_mob_broggok_poisoncloudAI;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/hellfire_citadel/blood_furnace/boss_the_maker.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/hellfire_citadel/blood_furnace/boss_the_maker.cpp (revision 223)
+++ /trunk/src/bindings/scripts/scripts/zone/hellfire_citadel/blood_furnace/boss_the_maker.cpp (revision 260)
@@ -128,4 +128,4 @@
     newscript->Name="boss_the_maker";
     newscript->GetAI = GetAI_boss_the_makerAI;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/hellfire_citadel/blood_furnace/boss_kelidan_the_breaker.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/hellfire_citadel/blood_furnace/boss_kelidan_the_breaker.cpp (revision 223)
+++ /trunk/src/bindings/scripts/scripts/zone/hellfire_citadel/blood_furnace/boss_kelidan_the_breaker.cpp (revision 260)
@@ -226,9 +226,9 @@
     newscript->Name="boss_kelidan_the_breaker";
     newscript->GetAI = GetAI_boss_kelidan_the_breaker;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="mob_shadowmoon_channeler";
     newscript->GetAI = GetAI_mob_shadowmoon_channeler;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/hellfire_citadel/hellfire_ramparts/boss_watchkeeper_gargolmar.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/hellfire_citadel/hellfire_ramparts/boss_watchkeeper_gargolmar.cpp (revision 229)
+++ /trunk/src/bindings/scripts/scripts/zone/hellfire_citadel/hellfire_ramparts/boss_watchkeeper_gargolmar.cpp (revision 260)
@@ -165,4 +165,4 @@
     newscript->Name="boss_watchkeeper_gargolmar";
     newscript->GetAI = GetAI_boss_watchkeeper_gargolmarAI;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/hellfire_citadel/hellfire_ramparts/boss_omor_the_unscarred.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/hellfire_citadel/hellfire_ramparts/boss_omor_the_unscarred.cpp (revision 166)
+++ /trunk/src/bindings/scripts/scripts/zone/hellfire_citadel/hellfire_ramparts/boss_omor_the_unscarred.cpp (revision 260)
@@ -210,4 +210,4 @@
     newscript->Name="boss_omor_the_unscarred";
     newscript->GetAI = GetAI_boss_omor_the_unscarredAI;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
